//
//  ViewController.swift
//  Aufgabenliste
//
//  Created by Holger Hinzberg on 06.11.17.
//  Copyright © 2017 Holger Hinzberg. All rights reserved.
//


import UIKit

class TabellenViewController: UITableViewController
{
    var aufgabenAblage : Aufgabenablage?
    // Eine Eigenschaft für die ausgewählte Aufgabe
    var gewählteAufgabe: Aufgabe?
    
    override func viewDidLoad()
    {
        super.viewDidLoad()
        self.aufgabenAblage = Aufgabenablage()
    }
        
    override func tableView(_ tableView: UITableView, numberOfRowsInSection section: Int) -> Int
    {
        return self.aufgabenAblage!.anzahlDerAufgaben()
    }
    
    override func tableView(_ tableView: UITableView, cellForRowAt indexPath: IndexPath) -> UITableViewCell
    {
        // Eine Aufgabe an der angegebenen Position
        // aus der Aufgabenablage holen
        let aufgabe = self.aufgabenAblage!.aufgabeAn(position: indexPath.row)
        let zelle = tableView.dequeueReusableCell(withIdentifier: "Zelle") as? Aufgabenzelle
        
        // Der Titel der Aufgabe wir dre Text der Zelle
        zelle?.titelLabel?.text = aufgabe?.Titel
        
        switch aufgabe!.Prioritaet
        {
        case Dringlichkeit.SehrWichtig:
            zelle?.prioritaetView?.backgroundColor = UIColor.red
        case Dringlichkeit.Wichtig:
            zelle?.prioritaetView?.backgroundColor = UIColor.yellow
        default:
            zelle?.prioritaetView?.backgroundColor = UIColor.green
        }
        
        return zelle!
    }
    
    override func tableView(_ tableView: UITableView, heightForRowAt indexPath: IndexPath) -> CGFloat
    {
        return 60
    }
    
    override func tableView(_ tableView: UITableView, didSelectRowAt indexPath: IndexPath)
    {
        let aufgabe = self.aufgabenAblage!.aufgabeAn(position: indexPath.row)
        if let aufgabe = aufgabe
        {
            print(aufgabe.Titel)
            self.gewählteAufgabe = aufgabe
            // Den Segue mit dem angegebenen Identifier ausführen
            self.performSegue(withIdentifier: "ZurDetailAnsicht", sender: nil)
        }
    }
    
    @IBAction func neueAufgabeButtonBeruehrt(_ sender: Any)
    {
        // Es gibt keine gewählte Aufgabe
        self.gewählteAufgabe = nil
        
        // Den Segue mit dem angegebenen Identifier ausführen
        self.performSegue(withIdentifier: "ZurDetailAnsicht", sender: nil)
    }
    
    func aufgabeEinfuegen(aufgabe:Aufgabe)
    {
        // Die Aufgabe der Ablage hinzufügen
        self.aufgabenAblage?.hinzufügen(aufgabe: aufgabe)
        // Das Tabellensteuerelement aktualisieren
        self.tableView.reloadData()
    }
    
    func aktualisieren()
    {
        // Das Tabellensteuerelement aktualisieren
        self.tableView.reloadData()
    }
    
    override func prepare(for segue: UIStoryboardSegue, sender: Any?)
    {
        if segue.identifier == "ZurDetailAnsicht"
        {
            if let ziel = segue.destination as? DetailViewController
            {
                // Der TabellenViewController übergibt sich
                // selbst als Verweis an den
                // DetailViewController
                ziel.tabellenUebersicht = self
            }
        }
    }
    
}

